package org.greenstone.gsdl3.gs3build.schema;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import java.util.List;

public abstract class SchemaNode
{
	public SchemaNode(Element element) throws SchemaException
	{	List childList = this._allocate();
		this.initialise(element, childList);
		System.out.println(element.getNodeName());
	}
	
	abstract protected List _allocate();

	protected void initialise(Element element, List childList) throws SchemaException
	{
		// TODO: check minimum, maximum occurrences etc.

		NodeList children = element.getChildNodes();
		if (children != null) {
			System.out.println("  " + children.getLength() + " children");
			for (int i = 0; i < children.getLength(); i ++)
			{ if (children.item(i).getNodeType() == org.w3c.dom.Node.ELEMENT_NODE) {
					Node child = children.item(i);

					String type = child.getNodeName();
					System.out.println("Child is " + type);

					if (type == null) {
						throw new SchemaException("Badly defined child - no name");
					}

					type = SchemaNode.getElementName(type);

					if (type.equals("element")) {
						SchemaElement elementChild = new SchemaElement((Element) children.item(i));
						childList.add(elementChild);
					}
					else {
						Object elementChild = SchemaNodeFactory.makeNode((Element) child);
						if (elementChild != null) {
							childList.add(elementChild);
						}
					}
					// TODO: do an abstraction between here and SchemaElement
				}
			}
		}
	}

	public static String getElementName(String fullname)
	{	if (fullname.indexOf(':') >= 0) {
			return fullname.substring(fullname.indexOf(':') + 1);
		}
		return fullname;
	}

	public static String getNamespace(String fullname)
	{	if (fullname.indexOf(':') >= 0) {
			return fullname.substring(0, fullname.indexOf(':'));
		}
		return null;
	}
}